bindings["p2k"] = {
	aa_global_toggle = {
		name = "Global Toggle",
		desc = "Toggles entire P2K's gui.",
		keys = {
			left_alt = 1,
			up = 1,
		},
	},
	ab_taskbar_shift = {
		name = "Shift Taskbar",
		desc = "Changes taskbar's orientation.",
		keys = {
			left_alt = 1,
			y = 1,
		},
	},
	ac_fps_lock = {
		name = "Lock FPS",
		desc = "Locks FPS to a value set in Frames window.",
		keys = {
			left_alt = 1,
			u = 1,
		},
	},
	ad_show_pointer = {
		name = "Show Pointer",
		desc = "Toggles whether pointer position will be marked or not.",
		keys = {
			left_alt = 1,
			p = 1,
		},
	},
	ae_show_camera = {
		name = "Show Camera",
		desc = "Toggles whether camera position will be marked or not.",
		keys = {
			left_alt = 1,
			left_ctrl = 1,
			p = 1,
		},
	},
	af_mute_logs = {
		name = "Mute Console Logs",
		desc = "Disables all non-essential logging to in-game console.",
		keys = {
			left_alt = 1,
			m = 1,
		},
	},
	ag_hide_trans = {
		name = "Hide Transformer Gizmo",
		desc = "Toggles on-screen transform editor.",
		keys = {
			left_alt = 1,
			g = 1,
		},
	},
	ah_trans_window = {
		name = "Open Transformer Window",
		desc = "Opens text-based transform editor.",
		keys = {
			left_alt = 1,
			left_ctrl = 1,
			g = 1,
		},
	},
	ai_text_mode = {
		name = "Text Display Mode",
		desc = "Changes from which end all the text will be displayed.",
		keys = {
			left_alt = 1,
			k = 1,
		},
	},
	
	ba_open_main = {
		name = "Open Main Window/Set Up The Workspace",
		desc = "Opens the Prospero2000 window or sets up the workspace if main window was already active.",
		keys = {
			left_alt = 1,
			o = 1,
		},
	},
	bb_stealth_main = {
		name = "Secretly Opens Main Window",
		desc = "Opens the Propspero2000 window in such a way that it does not clutter the UI while still giving you full access to [MAIN ONLY] hotkeys.",
		keys = {
			right_alt = 1,
			o = 1,
		},
	},
	bc_compact_close = {
		name = "Close All Windows/Change Taskbar Mode",
		desc = "Closes all opened windows in current dimension or changes taskbar mode if no windows were opened.",
		keys = {
			left_alt = 1,
			space = 1,
		},
	},
	bd_entity_radar = {
		name = "Activate Entity Radar",
		desc = "Hold to highlight all the entities on the screen.",
		keys = {
			left_alt = 1,
			s = 1,
		},
	},
	
	ca_next_dim = {
		name = "Next Dimension",
		desc = "Switches dimensions forwards.",
		keys = {
			left_alt = 1,
		},
	},
	cb_previous_dim = {
		name = "Previous Dimension",
		desc = "Switches dimensions backwards.",
		keys = {
			left_alt = 1,
		},
	},
	cc_next_window = {
		name = "Next Window",
		desc = "Makes next window active.",
		keys = {
			left_alt = 1,
			right = 1,
		},
	},
	cd_previous_window = {
		name = "Previous Window",
		desc = "Makes previous window active.",
		keys = {
			left_alt = 1,
			left = 1,
		},
	},
	ce_close_window = {
		name = "Close Window",
		desc = "Closes currently active window.",
		keys = {
			left_alt = 1,
			down = 1,
		},
	},
	
	da_capture = {
		name = "Capture/Open Captured",
		desc = "Captures the target near the pointer or opens its window if called again for the same one.",
		keys = {
			left_alt = 1,
			c = 1,
		},
	},
	db_open = {
		name = "Open Captured",
		desc = "Opens the currently captured entity.",
		keys = {
			right_alt = 1,
			c = 1,
		},
	},
	dc_uncapture = {
		name = "Uncapture",
		desc = "Uncaptures the captured target.",
		keys = {
			left_alt = 1,
			v = 1,
		},
	},
	de_delete_target = {
		name = "Delete Captured",
		desc = "Deletes currently captured target.",
		keys = {
			left_alt = 1,
		},
	},
	df_nuke = {
		name = "Delete Everything",
		desc = "Deletes every entity present except for the player.",
		keys = {
			left_alt = 1,
			right_alt = 1,
		},
	},
	
	ea_teleporter = {
		name = "Teleporter",
		desc = "[MAIN ONLY] Opens teleporter window.",
		keys = {
			left_alt = 1,
			keypad_7 = 1,
		},
	},
	eb_zoomer = {
		name = "Magnifier",
		desc = "[MAIN ONLY] Opens magnifier window.",
		keys = {
			left_alt = 1,
			keypad_8 = 1,
		},
	},
	ec_camera = {
		name = "Camera Controller",
		desc = "[MAIN ONLY] Opens camera controller window.",
		keys = {
			left_alt = 1,
			keypad_9 = 1,
		},
	},
	
	fa_script_1 = {
		name = "Script 1",
		desc = "Executes the first custom script.",
		keys = {
			left_alt = 1,
			keypad_1 = 1,
		},
	},
	fa_script_2 = {
		name = "Script 2",
		desc = "Executes the second custom script.",
		keys = {
			left_alt = 1,
			keypad_2 = 1,
		},
	},
	fa_script_3 = {
		name = "Script 3",
		desc = "Executes the third custom script.",
		keys = {
			left_alt = 1,
			keypad_3 = 1,
		},
	},
	fb_script_1_cont = {
		name = "Toggle Script 1",
		desc = "Toggles continuous mode for the first custom script.",
		keys = {
			left_ctrl = 1,
			keypad_1 = 1,
		},
	},
	fb_script_2_cont = {
		name = "Toggle Script 2",
		desc = "Toggles continuous mode for the second custom script.",
		keys = {
			left_ctrl = 1,
			keypad_2 = 1,
		},
	},
	fb_script_3_cont = {
		name = "Toggle Script 3",
		desc = "Toggles continuous mode for the third custom script.",
		keys = {
			left_ctrl = 1,
			keypad_3 = 1,
		},
	},
	
	za_nullspace = {
		name = "Nullspace",
		desc = "[KEYBOARD ONLY] Clears the input field.",
		keys = {
			left_ctrl = 1,
			backspace = 1,
		},
	},
	zb_right_null = {
		name = "Right Null",
		desc = "[KEYBOARD ONLY] Clears everything to the right of the pointer.",
		keys = {
			left_ctrl = 1,
			delete = 1,
		},
	},
	zc_more_keys = {
		name = "Extra Keys",
		desc = "[KEYBOARD ONLY] Opens advanced keyboard window.",
		keys = {
			left_alt = 1,
		},
	},
	zd_full_right = {
		name = "Full Right",
		desc = "[KEYBOARD ONLY] Moves the pointer all the way to the right.",
		keys = {
			left_ctrl = 1,
			right = 1,
		},
	},
	ze_full_left = {
		name = "Full Left",
		desc = "[KEYBOARD ONLY] Moves the pointer all the way to the left.",
		keys = {
			left_ctrl = 1,
			left = 1,
		},
	},
	zf_copy = {
		name = "Copy",
		desc = "[KEYBOARD ONLY] Copies the contents of the input field.",
		keys = {
			left_ctrl = 1,
			c = 1,
		},
	},
	zg_save = {
		name = "Save",
		desc = "[KEYBOARD ONLY] Copies the contents of the input field and saves them to the clipboard.",
		keys = {
			left_ctrl = 1,
			left_shift = 1,
			c = 1,
		},
	},
	zh_paste = {
		name = "Paste",
		desc = "[KEYBOARD ONLY] Pastes copied value into the input field.",
		keys = {
			left_ctrl = 1,
			v = 1,
		},
	},
	zi_replace = {
		name = "Replace",
		desc = "[KEYBOARD ONLY] Replaces the contents of the input field with copied value.",
		keys = {
			left_ctrl = 1,
			left_shift = 1,
			v = 1,
		},
	},
	zj_ctrl_lock = {
		name = "Controls Lock",
		desc = "[KEYBOARD ONLY] Toggles Controls Lock.",
		keys = {
			left_alt = 1,
			l = 1,
		},
	},
	zk_vip_switch = {
		name = "VIP Switch",
		desc = "[KEYBOARD ONLY] Switches VIP mode for P2K's bindings.",
		keys = {
			left_alt = 1,
			j = 1,
		},
	},
	zl_open_clipboard = {
		name = "Open Clipboard",
		desc = "[KEYBOARD ONLY] Opens the Clipboard.",
		keys = {
			left_alt = 1,
		},
	},
	zm_cancel_input = {
		name = "Cancel Input",
		desc = "[KEYBOARD ONLY] Exits input mode without saving.",
		keys = {
			down = 1,
		},
	},
	zn_next_layer = {
		name = "Next Layer",
		desc = "[EXTRA KEYBOARD ONLY] Switches to next layer.",
		keys = {
			right_alt = 1,
		},
	},
	zo_previous_layer = {
		name = "Previous Layer",
		desc = "[EXTRA KEYBOARD ONLY] Exits input mode without saving.",
		keys = {
			right_alt = 1,
		},
	},
	zp_extra_key_1 = {
		name = "Extra Key 1",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_7 = 1,
		},
	},
	zp_extra_key_2 =  {
		name = "Extra Key 2",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_8 = 1,
		},
	},
	zp_extra_key_3 =  {
		name = "Extra Key 3",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_9 = 1,
		},
	},
	zp_extra_key_4 =  {
		name = "Extra Key 4",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_4 = 1,
		},
	},
	zp_extra_key_5 =  {
		name = "Extra Key 5",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_5 = 1,
		},
	},
	zp_extra_key_6 =  {
		name = "Extra Key 6",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_6 = 1,
		},
	},
	zp_extra_key_7 =  {
		name = "Extra Key 7",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_2 = 1,
		},
	},
	zp_extra_key_8 =  {
		name = "Extra Key 8",
		desc = "[EXTRA KEYBOARD ONLY]",
		keys = {
			right_ctrl = 1,
			keypad_3 = 1,
		},
	},
}

bindings.p2k.ca_next_dim.keys["keypad_+"] = 1
bindings.p2k.cb_previous_dim.keys["keypad_-"] = 1
bindings.p2k.de_delete_target.keys["keypad_/"] = 1
bindings.p2k.df_nuke.keys["keypad_/"] = 1
bindings.p2k.zc_more_keys.keys["keypad_*"] = 1
bindings.p2k.zl_open_clipboard.keys["keypad_0"] = 1
bindings.p2k.zn_next_layer.keys["."] = 1
bindings.p2k.zo_previous_layer.keys[","] = 1

if( ModSettingGetNextValue( "p2k.MNEE_REBINDING" )) then
	bindings["p2k_kbd"] = {
		KEY_q = {
			name = "Key [q]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				q = 1,
			},
		},
		KEY_w = {
			name = "Key [w]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				w = 1,
			},
		},
		KEY_e = {
			name = "Key [e]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				e = 1,
			},
		},
		KEY_r = {
			name = "Key [r]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				r = 1,
			},
		},
		KEY_t = {
			name = "Key [t]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				t = 1,
			},
		},
		KEY_y = {
			name = "Key [y]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				y = 1,
			},
		},
		KEY_u = {
			name = "Key [u]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				u = 1,
			},
		},
		KEY_i = {
			name = "Key [i]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				i = 1,
			},
		},
		KEY_o = {
			name = "Key [o]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				o = 1,
			},
		},
		KEY_p = {
			name = "Key [p]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				p = 1,
			},
		},
		KEY_a = {
			name = "Key [a]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				a = 1,
			},
		},
		KEY_s = {
			name = "Key [s]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				s = 1,
			},
		},
		KEY_d = {
			name = "Key [d]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				d = 1,
			},
		},
		KEY_f = {
			name = "Key [f]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				f = 1,
			},
		},
		KEY_g = {
			name = "Key [g]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				g = 1,
			},
		},
		KEY_h = {
			name = "Key [h]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				h = 1,
			},
		},
		KEY_j = {
			name = "Key [j]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				j = 1,
			},
		},
		KEY_k = {
			name = "Key [k]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				k = 1,
			},
		},
		KEY_l = {
			name = "Key [l]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				l = 1,
			},
		},
		KEY_z = {
			name = "Key [z]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				z = 1,
			},
		},
		KEY_x = {
			name = "Key [x]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				x = 1,
			},
		},
		KEY_c = {
			name = "Key [c]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				c = 1,
			},
		},
		KEY_v = {
			name = "Key [v]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				v = 1,
			},
		},
		KEY_b = {
			name = "Key [b]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				b = 1,
			},
		},
		KEY_n = {
			name = "Key [n]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				n = 1,
			},
		},
		KEY_m = {
			name = "Key [m]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				m = 1,
			},
		},
		
		KEY_left_shift = {
			name = "Key [left_shift]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				left_shift = 1,
			},
		},
		KEY_space = {
			name = "Key [space]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				space = 1,
			},
		},
		KEY_backspace = {
			name = "Key [backspace]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				backspace = 1,
			},
		},
		KEY_delete = {
			name = "Key [delete]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				delete = 1,
			},
		},
		KEY_right = {
			name = "Key [right]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				right = 1,
			},
		},
		KEY_left = {
			name = "Key [left]",
			desc = "[KEYBOARD ONLY]",
			keys = {
				left = 1,
			},
		},
	}
	
	for i = 0,9 do
		bindings.p2k_kbd["KEY_"..i] = {
			name = "Key ["..i.."]",
			desc = "[KEYBOARD ONLY]",
			keys = {},
		}
		bindings.p2k_kbd["KEY_"..i].keys["keypad_"..i] = 1
	end
	
	bindings.p2k_kbd["KEY_."] = {
		name = "Key [.]",
		desc = "[KEYBOARD ONLY]",
		keys = {},
	}
	bindings.p2k_kbd["KEY_."].keys["keypad_."] = 1
	
	bindings.p2k_kbd["KEY_-"] = {
		name = "Key [-]",
		desc = "[KEYBOARD ONLY]",
		keys = {},
	}
	bindings.p2k_kbd["KEY_-"].keys["keypad_-"] = 1
	
	bindings.p2k_kbd["KEY_/"] = {
		name = "Key [/]",
		desc = "[SHIFTED KEYBOARD ONLY]",
		keys = {},
	}
	bindings.p2k_kbd["KEY_/"].keys["keypad_/"] = 1
	
	bindings.p2k_kbd["KEY__"] = {
		name = "Key [_]",
		desc = "[SHIFTED KEYBOARD ONLY]",
		keys = {},
	}
	bindings.p2k_kbd["KEY__"].keys["-"] = 1
end